<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */
require_once(Mage::getModuleDir('Module', 'CodeAlfa_JchOptimize') . '/lib/jchoptimize/loader.php');

class CodeAlfa_JchOptimize_Model_Observer
{

        /**
         * 
         * @param Varien_Event_Observer $observer
         * @return type
         */
        public function optimize(Varien_Event_Observer $observer)
        {
                $block = $observer->getData('block');

                if (get_class($block) != 'Mage_Page_Block_Html' 
                        || Mage::app()->getStore()->isAdmin() 
                        || $_GET['jchbackend'] == '1'
                        || !Mage::getStoreConfig('jchoptimizeconfig/basicoptions/enabled'))
                {
                        return;
                }

                define('_MAGE_EXEC', '1');

                if (!defined('JCH_VERSION'))
                {
                        define('JCH_VERSION', '1.0.0');
                }

//                $oResponse = $observer->getData('response');
//                $sHtml     = $oResponse->getBody();

                $oTransport = $observer->getData('transport');
                $sHtml      = $oTransport->getData('html');

                $options = Mage::getStoreConfig('jchoptimizeconfig');
                $options = call_user_func_array('array_merge', $options);

                try
                {
                        $sOptimizedHtml = JchOptimize::optimize($options, $sHtml);
//                        $oResponse->setBody($sOptimizedHtml);
                        $oTransport->setData('html', $sOptimizedHtml);
                }
                catch (Exception $e)
                {
                        JchOptimizeLogger::log($e->getMessage(), JchPlatformSettings::getInstance($options));
                }
        }

        /**
         * 
         * @param Varien_Event_Observer $observer
         */
        public function prepareAdminObject(Varien_Event_Observer $observer)
        {
                $controller = $observer->getData('controller_action');
                $section    = $controller->getRequest()->getParam('section');

                if ($section == 'jchoptimizeconfig')
                {
                        Mage::helper('jchoptimize')->getAdminObject();
                }
        }

        
}
