<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */

include_once(Mage::getModuleDir('Module', 'CodeAlfa_JchOptimize') . '/lib/jchoptimize/loader.php');

class CodeAlfa_JchOptimize_Adminhtml_AjaxController extends Mage_Adminhtml_Controller_Action
{

        public function fileTreeAction()
        {
                echo JchOptimizeAjax::fileTree();
                exit();
        }

        public function optimizeImagesAction()
        {
                echo JchOptimizeAjax::optimizeImages(JchPlatformPlugin::getPluginParams());
                exit();
        }

        public function postResultsAction()
        {
                $cnt    = JchPlatformUtility::get('cnt', NULL, 'int', 'get');
                $dir    = JchPlatformUtility::get('dir', '', 'string', 'get');
                $status = JchPlatformUtility::get('status', NULL, 'string', 'get');
                $msg    = JchPlatformUtility::get('msg', '', 'string', 'get');

                $session = Mage::getSingleton('core/session');

                $dir = JchPlatformUtility::decrypt($dir);

                if ($cnt !== FALSE && !is_null($cnt))
                {
                        $session->addSuccess(Mage::helper('jchoptimize')->__(sprintf('%1$d images optimized in %2$s', $cnt, $dir)));
                }
                elseif ($status !== FALSE && !is_null($status))
                {
                        $session->addError(Mage::helper('jchoptimize')->__(sprintf('Try again, the optimize image function failed with message: %1$s',
                                                                                   $msg)));
                }

                $this->_redirect('adminhtml/system_config/edit/section/jchoptimizeconfig');
        }

}
