<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */

class CodeAlfa_JchOptimize_Adminhtml_CachecleanerController extends Mage_Adminhtml_Controller_Action
{

        public function indexAction()
        {
                $session = Mage::getSingleton('core/session');
                
                try
                {
                        $cache = Mage::app()->getCacheInstance();
                        
                        if(!$cache->cleanType('jch_optimize_cache'))
                        {
                                throw new Exception(Mage::helper('jchoptimize')->__('Couldn\'t delete files'));
                        }
                        
                        if(!$cache->cleanType('block_html'))
                        {
                                throw new Exception(Mage::helper('jchoptimize')->__('Couldn\'t delete files'));
                        }
                                
                        $session->addSuccess(Mage::helper('jchoptimize')->__('Cache cleaned successfully'));
                }
                catch(Exception $e)
                {
                        $session->addError(Mage::helper('jchoptimize')->__('Cache clean action failed with message: ') . $e->getMessage());
                }
                
                $this->_redirect('adminhtml/system_config/edit/section/jchoptimizeconfig');
        }
}

