<?php

/**
 * JCH Optimize - Aggregate and minify external resources for optmized downloads
 * 
 * @author Samuel Marshall <sdmarshall73@gmail.com>
 * @copyright Copyright (c) 2010 Samuel Marshall
 * @license GNU/GPLv3, See LICENSE file
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * If LICENSE file missing, see <http://www.gnu.org/licenses/>.
 */


class JchPlatformHttp implements JchInterfaceHttp
{

        protected static $oHttpAdapter = NULL;
        protected static $available;
        protected static $instance     = NULL;

        public function available()
        {
                return self::$available;
        }

        public function request($sPath, $aPost = null, $aHeaders = null)
        {
                if (is_null($aPost))
                {
                        self::$oHttpAdapter->get($sPath);
                }

                $return = array(
                        'body' => self::$oHttpAdapter->getBody(),
                        'code' => self::$oHttpAdapter->getStatus()
                );

                return $return;
        }

        private function __construct()
        {
                try
                {
                        self::$oHttpAdapter = Mage_HTTP_Client::getInstance();
                        self::$oHttpAdapter->setTimeout(10);

                        if (self::$oHttpAdapter instanceof Mage_HTTP_Client_Curl)
                        {
                                self::$oHttpAdapter->setOption(CURLOPT_SSL_VERIFYPEER, TRUE);
                                self::$oHttpAdapter->setOption(
                                        CURLOPT_CAINFO, Mage::getModuleDir('Module', 'CodeAlfa_JchOptimize') . '/lib/jchoptimize/libs/cacert.pem'
                                );
                        }

                        self::$available = TRUE;
                }
                catch (Exception $ex)
                {
                        self::$available = FALSE;
                }
        }

        public static function getHttpAdapter()
        {
                if (is_null(self::$instance))
                {
                        self::$instance = new JchPlatformHttp;
                }

                return self::$instance;
        }

}
